%define major 2
%define libname %mklibname drm %{major}
%define develname %mklibname drm -d
%define staticdevelname %mklibname drm -d -s

%define intel_major 1
%define libintel %mklibname drm_intel %{intel_major}
%define nouveau_major 1
%define libnouveau %mklibname drm_nouveau %{nouveau_major}
%define radeon_major 1
%define libradeon %mklibname drm_radeon %{radeon_major}

Summary:	Userspace interface to kernel DRM services
Name:		libdrm
Version:	2.4.11
Release:	%mkrel 0.0.1
Group:		System/Libraries
License:	MIT/X11
URL:		http://xorg.freedesktop.org
Source0:	http://dri.freedesktop.org/libdrm/libdrm-%{version}.tar.bz2
Source1: 91-drm-modeset.rules

Patch0100:  0100-RH-libdrm-make-dri-perms-okay-v1.1.patch
Patch0101:  0101-RH-libdrm-2.4.0-no-bc-v1.3.patch
Patch0102:  0102-RH-libdrm-radeon-v1.7.patch

Patch0500:  0500-improve-waiting-for-dri-device-to-appear-when-system.patch

BuildRequires:	kernel-headers >= 1:2.6.27.4-3mnb2
BuildRequires:	libpthread-stubs
BuildRequires:	x11-util-macros >= 1.0.1
BuildRequires: udev-devel
Conflicts:	kernel-headers <= 1:2.6.27.4-2mnb2
BuildRoot:	%{_tmppath}/%{name}-root

%description
Userspace interface to kernel DRM services

%package common
Summary:	Common files for the userspace interface to kernel DRM services
Group:		System/Libraries

%description common
Common files for the userspace interface to kernel DRM services

%package -n	%{libname}
Summary:	Userspace interface to kernel DRM services
Group:		System/Libraries
Provides:	%{name} = %{version}
Requires: %{name}-common

%description -n	%{libname}
Userspace interface to kernel DRM services

%package -n	%{libintel}
Summary:	Shared library for Intel kernel DRM services
Group:		System/Libraries
Conflicts:	%{_lib}drm2 < 2.4.5-2

%description -n %{libintel}
Shared library for Intel kernel Direct Rendering Manager services.

%package -n	%{libnouveau}
Summary:	Shared library for Nouveau kernel DRM services
Group:		System/Libraries

%description -n %{libnouveau}
Shared library for Nouveau kernel Direct Rendering Manager services.

%package -n	%{libradeon}
Summary:	Shared library for Radeon kernel DRM services
Group:		System/Libraries
Conflicts:	%{_lib}drm2 < 2.4.5-2

%description -n %{libradeon}
Shared library for Radeon kernel Direct Rendering Manager services.

%package -n	%{develname}
Summary:	Development files for %{name}
Group:		Development/X11
Requires:	%{libname} = %{version}
Requires:	%{libintel} = %{version}
Requires:	%{libnouveau} = %{version}
Requires:	%{libradeon} = %{version}
Provides:       %{name}-devel = %{version}-%{release}
Obsoletes:      %{mklibname drm 2 -d}
Obsoletes:	drm-nouveau-devel < 2.3.0-2.20090111.2

%description -n	%{develname}
Development files for %{name}

%package -n	%{staticdevelname}
Summary:	Static development files for %{name}
Group:		Development/X11
Requires:	%{name}-devel >= %{version}
Requires:	%{libname} = %{version}
Provides:       %{name}-static-devel = %{version}-%{release}
Obsoletes:      %{mklibname drm 2 -d -s}

%description -n	%{staticdevelname}
Static development files for %{name}

%prep

%setup -q
%apply_patches

%build
# (cg) Needed for radeon stuff
# and patch4
autoreconf -v --install || exit 1
%configure2_5x \
    --enable-udev \
    --enable-static \
    --enable-nouveau-experimental-api

%make

%install
rm -rf %{buildroot}

%makeinstall_std 
mkdir -p %{buildroot}%{_sysconfdir}/udev/rules.d/
install -m 0644 %{SOURCE1} %{buildroot}%{_sysconfdir}/udev/rules.d/

find %{buildroot} -type f -name '*.la' -exec rm -f {} \;

# (cg) Note that RH remove drm.h drm_mode.h drm_sarea.h r300_reg.h via_3d_reg.h
# and we should perhaps do the same? (previous attempts have not gone well :)

%if %mdkversion < 200900
%post -n %{libname} -p /sbin/ldconfig
%endif

%if %mdkversion < 200900
%postun -n %{libname} -p /sbin/ldconfig
%endif

%clean
rm -rf %{buildroot}

%files common
%defattr(-,root,root)
%{_sysconfdir}/udev/rules.d/91-drm-modeset.rules

%files -n %{libname}
%defattr(-,root,root)
%{_libdir}/libdrm.so.%{major}*

%files -n %{libintel}
%defattr(-,root,root)
%{_libdir}/libdrm_intel.so.%{intel_major}*

%files -n %{libnouveau}
%defattr(-,root,root)
%{_libdir}/libdrm_nouveau.so.%{nouveau_major}*

%files -n %{libradeon}
%defattr(-,root,root)
%{_libdir}/libdrm_radeon.so.%{radeon_major}*

%files -n %{develname}
%defattr(-,root,root)
%{_includedir}/drm
%{_includedir}/nouveau
%{_includedir}/*.h
%{_libdir}/libdrm*.so
%{_libdir}/pkgconfig/libdrm*.pc

%files -n %{staticdevelname}
%defattr(-,root,root)
%{_libdir}/*.a


%changelog
* Wed May 20 2009 Colin Guthrie <cguthrie@mandriva.org> 2.4.11-0.0.1mdv2009.1
+ Revision: 377978
- BuildRequires udev-devel
- New version: 2.4.11
- Copy current
- Use %%apply_patches
- Include a couple of intel fixes from upstream
- Remove old file not referenced in SPEC
- New version: 2.4.9
- Drop nouveau headers patch (fixed upstream)
- New version: 2.4.5
- Drop upstream patches
- New version: 2.4.4
- Fix bogus provides
- Update to 2.4.3
- Enable udev support
- Liberate patches from Fedora
- Install udev rules for permissions
- Allow activation of kernel modesetting via kernel cmdline
- Install all headers (the ones from kernel-headers are, like, so last season)
- Unrevert the symbol change commit (intel driver just needs rebuild)
- Fix a crash by reverting upstream commit (for now)
- New version: 2.4.1
- Prevent a lockup in intel_bufmgr_fake
- Add missing buildrequire for libpthread-stubs
- New version: 2.4.0

  + Frederic Crozat <fcrozat@mandriva.com>
    - Increase timeout for dri detection, in speedboot mode only (Mdv bug #49490)
    - Enable patch 5 again, but use upstream timing
    - Disable patch6, it is causing 1min timeout on some systems
    - Patch5: improve wait on dri devices when system is busy (Mdv bug #49490)

  + Anssi Hannula <anssi@mandriva.org>
    - obsolete drm-nouveau-devel in correct package
    - enable experimental nouveau api
    - add missing nouveau headers (missing-nouveau-headers.patch)
    - fix requires of devel package
    - own /usr/include/drm
    - split libdrm_intel and libdrm_radeon, their major differs
    - fix group
    - drop duplicate requires
    - ensure major correctness
    - devel obsoletes drm-nouveau-devel

  + Herton Ronaldo Krzesinski <herton@mandriva.com.br>
    - Remove bad worded and unecessary /etc/modprobe.d/i915modeset
      (also it prevents passing custom options to i915 using modprobe)
    - Conflicts with kernel-headers package because of headers being
      provided again by libdrm.
    - Rebuild because of eaten static-devel package in latest submit.
    - libdrm-devel: remove files provided by kernel-headers.
    - Fix buildrequires version match for kernel-headers.
    - Rebuild with kernel-headers 2.6.27.4-1mnb2

  + Ander Conselvan de Oliveira <ander@mandriva.com>
    - Cherry pick "intel: libdrm support for fence management in execbuf" from master.
      This is needed to enable tiled rendering on intel pre-i965 hardware (cf.
      svn revision 342151 for intel driver).
    - Update to verseion 2.3.1

  + Thierry Vignaud <tvignaud@mandriva.com>
    - rebuild
    - BuildRequires x11-proto-devel for X11/Xfuncproto.h
    - rebuild
    - kill re-definition of %%buildroot on Pixel's request

  + Pixel <pixel@mandriva.com>
    - do not call ldconfig in %%post/%%postun, it is now handled by filetriggers

  + Paulo Andrade <pcpa@mandriva.com.br>
    - Revert build requires.
    - Update BuildRequires and rebuild.
      Also disable patch1 as it is being used just to "document" functions called
      from the X Server.
    - Initial listing of symbols required by the ati driver. This is for now a noop
      patch as libraries at first will have all symbols visible.

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Oden Eriksson <oeriksson@mandriva.com>
    - cleanup borked deps
    - new devel name

